MAZE   	ORG	0B000H
 HOFBEG	EQU	0C000H		;START OF MAZE
 	CALL	0A7FH		;WIDTH & LENGTH IN HL
 	PUSH	HL
 	LD	HL,0000H	;ZERO TO
 	LD	(RNDLOK),HL	;RANDOM POINTER
 	POP	DE		;HOR/VER IN DE
 	LD	HL,HOFBEG	;START CODE
 	LD	A,D		;HOR. DIMENSION
 	PUSH	AF		;SAVE IT
 	ADD	A,2		;PLUS 211
 	LD	B,A		;COUNTER
 VUL	LD	(HL),40H	;TOPSIDE
 	INC	HL		;NEXT BYTE
 	DJNZ	VUL		;UNTIL READY
 	INC	HL		;1ST LOCATION
 	PUSH	HL		;TO STACK
 	POP	IX		;IX=1ST LOCATION
 	DEC	HL		;CORRECT IT
 	POP	AF		;HOR.DIM (ORIG)
 	LD	B,E		;VER.DIM IN B
 INVUL	PUSH	BC		;SAVE THEM
 	PUSH	AF		;TO STACK
 	POP	BC		;HOR.DIM IN B
 ;TOP OF STACK IS NOW VER.DIM
 	LD	(HL),40H	;1ST BYTE (LEFT ONE)
 	INC	HL
 VUL2	LD	(HL),00H	;FILL WITH ZERO
 	INC	HL		;NEXT BYTE
 	DJNZ	VUL2
 	LD	(HL),40H	;RIGHT ONE
 	INC	HL		;NEXT BYTE
 	POP	BC		;VER.COUNTER IN B
 	DJNZ	INVUL		;REPEAT IT
 ;NOW THE BOTTOM HALF
 	ADD	A,2		;PLUS 2
 	LD	B,A		;MAKE IT THE COUNTER
 VUL3	LD	(HL),40H
 	INC	HL		;PLUS 1
 	DJNZ	VUL3
 	LD	(HL),00H	;FILL WITH ZERO
 	INC	HL
 	LD	(HL),0FFH	;END MARKER
 ;THAT'S THE WHOLE MAZE
 	LD	A,R		;RANDOM VALUE
 AFTREK	SUB	D		;MINUS HOR.VALUE
 	JR	NC,AFTREK	;POSITIVE, THEN AGAIN
 	ADD	A,D		;ADD IT AGAIN
 ;THAT IS THE HOR.RANDOM VALUE
 	PUSH	IX		;1ST LOCATION MAZE
 	POP	HL		;PUT IT IN HL
 	LD	C,A		;BC=00'AA'
 	ADD	HL,BC		;FIRST BOX
 	LD	(HL),01H	;OPEN UPSIDE
 	LD	A,D		;HOR.VALUE
 	INC	A		;PLUS 1
 	INC	A		;PLUS 1
 	LD	C,A		;C=HOR.VALUE + 2
 	PUSH	BC		;SAVE IT
 	POP	DE		;IN DE
 ;DE NOW CONTAINS THE VER.MOVEMENT THROUGH THE MAZE
 RANDOM	LD	A,R 		;RANDOM VALUE
 	PUSH	HL		;SAVE...
 	PUSH	DE		;REGISTERS
 	LD	HL,(RNDLOK)	;GET RANDOM POINTER
 	LD	D,0
 	LD	E,A
 	ADD	HL,DE		;ADD RND VALUE
 	LD	A,(HL)		;GET THE BYTE
 	LD	(RNDLOK),HL	;NEW POINTER
 	POP	DE		;GET THE
 	POP	HL		;REGISTERS
 	AND	03H		;MASK OUT
 	PUSH	HL		;OLD HL TO STACK
 ;BY MASKING OUT WITH 'AND 03' WE NOW HAVE A VALUE
 ;BETWEEN 0 AND 3 (THE 4 DIRECTIONS)
 	LD	B,5		;COUNTER
 	JR	K0123
 LOOP	LD	A,B		;COUNTER IS DIRECTION
 	DEC	A		;COMPENSATE
 K0123	OR	A 		;IS IT ZERO?
 	LD	C,(HL)		;OLD VALUE IN C
 	JR	Z,NUL
 	CP	01H		;IS IT A ONE?
 	JR	Z,EEN
 	CP	02H		;IS IT A TWO?
 	JR	Z,TWEE
 ;IF IT IS NOT A 0,1 OR 2 THEN IT IS A 3
 DRIE	SET	3,(HL)		;OPEN LEFT
 	DEC	HL		;ONE PLACE TO THE LEFT
 	XOR	A		;ZEROING A
 	CP	(HL)		;NEW ONE ALSO A ZERO?
 	JR	Z,DRIE2		;YES, THEN JUMP
 	JR	FOUT
 DRIE2	POP	IY 		;NO NEED FOR OLD HL
 	SET	1,(HL)		;OPEN RIGHT
 	JR	RANDOM		;NEXT BOX
 NUL	SET	0,(HL)		;OPEN UP
 	XOR	A		;ZEROING A
 	SBC	HL,DE		;ONE BOX UP
 	CP	(HL)		;IS IT ZERO?
 	JR	Z,NUL2		;YES, THEN JUMP
 	JR	FOUT		;TO END OF LOOP
 NUL2	POP	IY		;NO NEED OF OLD HL
 	SET	2,(HL)		;OPEN BOTTOM
 	JR	RANDOM		;NEXT BOX
 EEN	SET	1,(HL)		;OPEN RIGHT
 	INC	HL		;ONE BOX TO THE RIGHT
 	XOR	A
 	CP	(HL)
 	JR	Z,EEN2
 	JR	FOUT
 EEN2	POP	IY		;NO NEED OF OLD HL
 	SET	3,(HL)		;OPEN LEFT
 	JR	RANDOM		;NEXT BOX
 TWEE	SET	2,(HL)		;OPEN BOTTOM
 	ADD	HL,DE		;ONE BOX DOWN
 	XOR	A
 	CP	(HL)
 	JR	Z,TWEE2
 	JR	FOUT
 TWEE2	POP	IY 		;NO NEED OF OLD HL
 	SET	0,(HL)		;OPEN UP
 	JR	RANDOM
 ;
 ;IF WE COME HERE THEN IT WAS NOT POSSIBLE TO FILL
 ;A BOX. SO WE HAVE TO GO THROUGH THE LOOP AGAIN
 ;
 FOUT	POP	HL 		;OLD BOX BA
 	LD	(HL),C		;OLD VALUE BACK
 	PUSH	HL		;HL TO STACK AGAIN
 	DJNZ	LOOP
 	POP	HL		;IX TO MUCH PUSHED
 ;IF WE ARE HERE THEN WE CAN'T GO ANY WAY
 ;THEN WE HAVE TO DO THE FOLLOWING
 VASTGL	PUSH	IX 		;1ST LOCATION
 	POP	HL		;TO HL
 ANUL	XOR	A		;ZEROING A
 	LD	C,0		;BC IS ZERO NOW
 	CPIR			;FIND A ZERO
 	BIT	7,(HL)		;IS IT FF?
 	JR	NZ,BASIC	;YES, THEN TO BASIC
 	CALL	TEST		;LOOK FOR 0 OR 64
 ;IF YES THEN WE MAY NOT USE THIS BOX
 	JR	C,RECHTS
 	DEC	HL		;1 BOX BACK
 	DEC	HL		;AND AGAIN ONE BOX
 	CALL	TEST		;LOOK AGAIN
 	JR	C,LINKS		;TO THE LEFT
 	INC	HL		;NEXT BOX
 	INC	HL		;AND NEXT AGAIN
 	JR	ANUL		;EXAMINE
 RECHTS	SET	3,(HL) 		;OPEN LEFT
 	DEC	HL		;TO THE LEFT
 	SET	1,(HL)		;OPEN RIGHT
 	JP	RANDOM		;GO AGAIN
 LINKS	SET	1,(HL) 		;OPEN RIGHT
 	INC	HL		;TO THE RIGHT
 	SET	3,(HL)		;OPEN LEFT
 	JP	RANDOM		;GO AGAIN
 BASIC	XOR	A 		;ZEROING A
 	SBC	HL,DE		;1 ROW UP
 ;HL POINTS TO 1ST BOX OF THE BOTTOM ROW
 	LD	A,E		;HOR.+2 IN A
 	DEC	A		;HOR.+1 IN A
 	DEC	A		;HOR. IN A
 	LD	D,A		;HOR.VALUE TO D
 	LD	A,R		;RANDOM VALUE
 AFTR	SUB	D		;HOR.VALUE MINUS
 	JR	NC,AFTR		;TILL IT IS POSITIVE
 	ADD	A,D		;ADD AGAIN
 	LD	B,00H
 	LD	C,A		;BC='00AA
 	ADD	HL,BC
 	SET	0,(HL)		;OPEN UP
 	RET
 TEST	LD	A,(HL)		;GET VALUE
 	OR	A		;SET THE FLAGS
 	RET	Z		;RETURN IF ZERO
 	CP	64		;<64?
 	RET			;THEN CARRY IS 1
 RNDLOK	DEFW	0000H 		;RANDOM POINTER
 	END	402DH		;"DOS READY"
